// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	test PsfDataServer
//
#include "CalServer.h"
#include "Celestial.h"
#include "common.h"

using namespace std;

int main()
{
	calServer.ccf()->registerNewCifEntry("./XRT1_XPSF_0003.CCF");
	PsfDataServer *pds = 0; pds = calServer.getAtom(pds);

	const double NBETA = 100000.,
                 DELTA_BETA = .5,   //  beta span
                 binWidth = DELTA_BETA/NBETA;

	Spectrum spec(pds->dispersionFigureDistribution(20.,
                                                    binWidth*DEG_TO_RAD,
                                                    1.,
                                                    .65));
	unsigned N = spec.size();
	double fm = 0.;
	for (unsigned n=0; n<N; ++n) {
		fm += DBL(n)*spec[n];
		cout<<n<<' '<<spec[n]<<endl;
	}
	cerr<<"first moment: "<<setprecision(16)<<fm<<endl;
	cerr<<"first moment: "<<setprecision(16)<<spec.firstMoment()<<endl;

	return 0;
}
