// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	test the AbsorptionDataServer class
//
#include <iostream>
#include <cassert>
#include "CalServer.h"
#include "Ccf.h"
#include "ScaleFactorServer.h"

using namespace std;

/*
namespace {
bool isClose(double a, double b)
{
    return fabs(a)/fabs(b)-1. < 1.e-5;
}
}
*/

int main()
{
	//	setup the the Cal server
	Xmm::Instrument instrument = Xmm::EMOS1;
	calServer.setInstrument(instrument);
	calServer.state()->ccd()->set(1);
	calServer.state()->filter()->set(Xmm::toFilter("Thin1"));

	//	get the FWCDataServer
	ScaleFactorServer *sds = 0; sds = calServer.getAtom(sds);
        string idxband="Hard";
        cout<<" EMOS1, "<<idxband<<endl;
        SImage mapv = sds->getScaleFactorImage(idxband);
        float d34 = mapv[93][100];
        float d99 = mapv[100][149];
        cout<<" SF image([0,0],[93,100],[100,149]): "<<mapv[0][0]<<" "<<mapv[93][100]<<" "<<mapv[100][149]<<endl;
        idxband="Soft";
        cout<<idxband<<endl;
	sds = calServer.getAtom(sds);
        SImage mapv2 = sds->getScaleFactorImage(idxband);
        cout<<" SF image([0,0],[93,100],[100,149]): "<<mapv2[0][0]<<" "<<mapv2[93][100]<<" "<<mapv2[100][149]<<endl;

        instrument = Xmm::EPN;
        calServer.setInstrument(instrument);
	calServer.state()->filter()->set(Xmm::toFilter("Thick"));
        cout<<" EPN, Thick"<<endl;
        cout<<idxband<<endl;
	sds = calServer.getAtom(sds);
        SImage mapv3 = sds->getScaleFactorImage(idxband);

       //  const SImage &map3 = sds->getSWCXImage(band);
        cout<<" SF image([0,0],[93,100],[100,149]): "<<mapv3[0][0]<<" "<<mapv3[93][100]<<" "<<mapv3[100][149]<<endl;
        //cout<<" SWCX image([0,0],[193,300],[350,149]): "<<map3[0][0]<<" "<<map3[193][300]<<" "<<map3[350][149]<<endl;

        // Test a failure mode
        //idxband="XX";
        //cout<<idxband<<" Thick"<<endl;
        //mapv = sds->getScaleFactorImage(idxband);
        //const SImage &map4 = sds->getSWCXImage(band);

	return 0;
}







